/*  Copyright (c) 2006 by Azure Dynamics
	All rights reserved.  This software embodies unpublished proprietary
	and trade secret information of Azure Dynamics.  Any copying,
	disclosure or transmission not expressly authorized by the owner
	is expressly prohibited.  Azure Dynamics retains exclusive
	ownership of all intellectual property rights in this software,
	including all copyright, trade secret and patent rights.

    $Id: memtypes28x.h 9469 2008-08-25 21:02:51Z azure\csmith $

*/

/* This file defines portable and intuitive variable types according to
   J.J. Labrosse "MicroC/OS-II The Real Time Kernel".

   (bja)
*/

#ifndef MEMTYPES470M_H_
#define MEMTYPES470M_H_

/* Some useful definitions */

#ifndef NULL
#define NULL (0)
#endif

#ifdef TRUE
#undef TRUE
#endif

#ifdef FALSE
#undef FALSE
#endif

#ifndef __LCLINT__ /* required for Lint-checking */

typedef enum eBOOLEAN {FALSE = 0, TRUE = 1} BOOLEAN;

typedef unsigned char INT8U;
typedef char   INT8S;

typedef unsigned short  INT16U;
typedef short    INT16S;
typedef unsigned long INT32U;
typedef long   INT32S;
typedef float         FP32;
/* Attention: no 64 floating point variables exist! */

#else

#define BOOLEAN unsigned char
#define INT8U unsigned char
#define INT8S char
#define INT16U unsigned short
#define INT16S short
#define INT32U unsigned long // this is also an int
#define INT32S long
#define FP32 float

#endif /* __LCLINT__ */

typedef int             int16;
typedef long            int32;
typedef unsigned int    Uint16;
typedef unsigned long   Uint32;
typedef float           float32;
typedef long double     float64;

#define INTADDR INT32U // 28x DSPs use 32 bit addressing

#endif /* MEMTYPES470M_H_ */
