/** @file sys_exceptions.h
*   @brief Vectored Interrupt Module Header File
*   @date 15.March.2011
*   @version 1.00.000
*   
*   This file contains:
*   - Cortex-M3 Exceptions : Declarations
*/

/* (c) Texas Instruments 2009, All rights reserved. */

#ifndef __SYS_EXCEPTIONS_H__
#define __SYS_EXCEPTIONS_H__


void _NMI(void);		         /* Non-maskable Interrupt Handler 	*/
void _Hard_Fault(void);		     /* Hard Fault Handler			*/
void _Memory_Management(void);	 /* MPU mismatch,access violation Handler*/
void _Bus_Fault(void);		     /* Bus Fault Handler 			*/
void _Usage_Fault(void);	     /* Usage Fault Handler 			*/
void _Reserved(void);		     /* Reserved - Not to be used 		*/
void _SVC_Call(void);		     /* System service call Handler		*/
void _Debug_Monitor(void);	     /* Debug Monitor 			*/
void _Pend_SV(void);		     /* Pendable request for system service  */

#endif
