/** @file system.c 
*   @brief System Driver Source File
*   @date 15.March.2011
*   @version 1.00.000
*
*   This file contains:
*   - API Funcions
*   .
*   which are relevant for the System driver.
*/

/* (c) Texas Instruments 2011, All rights reserved. */

#include "sys_vim.h"


#pragma DATA_SECTION(VIM_TABLE, ".vim_table");

const unsigned int VIM_TABLE[48] = 
{
 
 (unsigned int) &_NMI,	/* Channel 0 */

#if VIM_CONFIG
 
 (unsigned int) &Dummy_ISR,   			/* Channel 1 */


#if 1
 (unsigned int) &esmLowInterrupt,	/* Channel 2 */
#else
 (unsigned int) &Dummy_ISR,			/* Channel 2 */
#endif


#if 0		
 (unsigned int) &sysSWInterrupt,	/* Channel 3 */
#else
 (unsigned int) &Dummy_ISR,			/* Channel 3 */
#endif


#if 0
 (unsigned int) &rtiCompare0Interrupt,	/* Channel 4 */
#else
 (unsigned int) &Dummy_ISR,			/* Channel 4 */
#endif


#if 0
 (unsigned int) &rtiCompare1Interrupt,	/* Channel 5 */
#else
 (unsigned int) &Dummy_ISR,			/* Channel 5 */
#endif


#if 0
 (unsigned int) &rtiCompare2Interrupt,	/* Channel 6 */
#else
 (unsigned int) &Dummy_ISR,			/* Channel 6 */
#endif


#if 0
 (unsigned int) &rtiCompare3Interrupt,        /* Channel 7 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 7 */
#endif


#if 0
 (unsigned int) &rtiOverflow0Interrupt,       /* Channel 8 */
#else
 (unsigned int) &Dummy_ISR,                    /* Channel 8 */
#endif


#if 0
 (unsigned int) &rtiOverflow1Interrupt,       /* Channel 9 */
#else
 (unsigned int) &Dummy_ISR,                    /* Channel 9 */
#endif


#if 0
 (unsigned int) &Dummy_ISR,       /* Channel 10 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 10 */
#endif

#if 0
 (unsigned int) &gioHighLevelInterrupt,       /* Channel 11 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 11 */
#endif


#if 0
 (unsigned int) &gioLowLevelInterrupt,       /* Channel 12 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 12 */
#endif


#if 0
 (unsigned int) &hetHighLevelInterrupt,       /* Channel 13 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 13 */
#endif


#if 0
 (unsigned int) &hetLowLevelInterrupt,       /* Channel 14 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 14 */
#endif


#if 0
 (unsigned int) &spi1LowLevelInterrupt,       /* Channel 15 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 15 */
#endif


#if 0
 (unsigned int) &spi1HighLevelInterrupt,       /* Channel 16 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 16 */
#endif


#if 0
 (unsigned int) &Dummy_ISR,       /* Channel 17 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 17 */
#endif


#if 0
 (unsigned int) &sci2HighLevelInterrupt,       /* Channel 18 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 18 */
#endif


#if 0
 (unsigned int) &sci2LowLevelInterrupt,       /* Channel 19 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 19 */
#endif


#if 0
 (unsigned int) &sci1HighLevelInterrupt,       /* Channel 20 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 20 */
#endif


#if 0
 (unsigned int) &sci1LowLevelInterrupt,       /* Channel 21 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 21 */
#endif


#if 0
 (unsigned int) &can1HighLevelInterrupt,       /* Channel 22 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 22 */
#endif


#if 0
 (unsigned int) &can1LowLevelInterrupt,       /* Channel 23 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 23 */
#endif


#if 0
 (unsigned int) &adcGroup0Interrupt,       /* Channel 24 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 24 */
#endif


#if 0
 (unsigned int) &adcGroup1Interrupt,       /* Channel 25 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 25 */
#endif


#if 0
 (unsigned int) &adcGroup2Interrupt,       /* Channel 26 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 26 */
#endif


#if 0
 (unsigned int) &spi2LowLevelInterrupt,       /* Channel 27 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 27 */
#endif


#if 0
 (unsigned int) &spi2HighLevelInterrupt,       /* Channel 28 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 28 */
#endif


#if 0
 (unsigned int) &can2HighLevelInterrupt,       /* Channel 29 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 29 */
#endif


#if 0
 (unsigned int) &can2LowLevelInterrupt,       /* Channel 30 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 30 */
#endif


#if 0
 (unsigned int) &Dummy_ISR,       /* Channel 31 */
#else
 (unsigned int) &Dummy_ISR,                     /* Channel 31 */
#endif


#if 0
 (unsigned int) &spi3LowLevelInterrupt,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &spi3HighLevelInterrupt,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,            /* Channel 39 */
#else
 (unsigned int) &Dummy_ISR,                          /* Channel 39 */
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,
#else
 (unsigned int) &Dummy_ISR,
#endif


#if 0
 (unsigned int) &Dummy_ISR,           /* Channel 47 */
#else
 (unsigned int) &Dummy_ISR,                         /* Channel 47 */
#endif


#endif

};



/** @fn void Dummy_ISR(void)
*   @brief ISR for undefined interrupts
*
*   The undefined inturrupts will have this function as an ISR.
*
*/


void Dummy_ISR(void)
{
/* USER CODE BEGIN (0) */
/* USER CODE END */
  for(;;);                                     /* .... wait here */
}




/** @fn void esmLowInterrupt(void)
*   @brief ESM Low Interrupt
*
*   ISR function for ESM Low Interrupt.
*
*/

void esmLowInterrupt(void)
{
/* USER CODE BEGIN (1) */
/* USER CODE END */
  for(;;);                                     /* .... wait here */
}


/** @fn void captureEventSource0(void)
*   @brief Capture Event Source 0
*
*   Function to chose a interrupt channel to Capture RTI counter capture 0.
*
*/

void captureEventSource0()  /* Capture Event Source 0 -> RTI CAPCNTR0 */
{
    vimREG->CAPEVTSRC0 = 0;
/* USER CODE BEGIN (2) */
/* USER CODE END */
}




/** @fn void captureEventSource0(void)
*   @brief Capture Event Source 0
*
*   Function to chose a interrupt channel to Capture RTI counter capture 1 .
*
*/

void captureEventSource1()  /* Capture Event Source 1 -> RTI CAPCNTR1 */
{
    vimREG->CAPEVTSRC1 = 0;
/* USER CODE BEGIN (3) */
/* USER CODE END */
}





/** @fn void nestEnable(void)
*   @brief Enable nested interrupts
*
*   Function to enable interrupt nesting upto 8 levels.
*
*/

void nestEnable(void)
{
    vimREG->NESTCTL = 0x0A;
}



/** @fn void vimCfg(void)
*   @brief VIM Configuration
*
*   Function to configure VIM.
*
*/

void vimCfg(void)
{	
#if 1
       
	/* set NMI/ISR priorities */
    vimREG->NMIPR0 =  (1U <<  2U)
                    | (0U <<  3U)
                    | (0U <<  4U)
                    | (0U <<  5U)
                    | (0U <<  6U)
                    | (0U <<  7U)
                    | (0U <<  8U)
                    | (0U <<  9U)
                    | (0U << 10U)
                    | (0U << 11U)
                    | (0U << 12U)
                    | (0U << 13U)
                    | (0U << 14U)
                    | (0U << 15U)
                    | (0U << 16U)
                    | (0U << 17U)
                    | (0U << 18U)
                    | (0U << 19U)
                    | (0U << 20U)
                    | (0U << 21U)
                    | (0U << 22U)
                    | (0U << 23U)
                    | (0U << 24U)
                    | (0U << 25U)
                    | (0U << 26U)
                    | (0U << 27U)
                    | (0U << 28U)
                    | (0U << 29U)
                    | (0U << 30U)
                    | (0U << 31U);

    vimREG->NMIPR1 =  0U
                    | (0U <<  1U)
                    | (0U <<  2U)
                    | (0U <<  3U)
                    | (0U <<  4U)
                    | (0U <<  5U)
                    | (0U <<  6U)
                    | (0U <<  7U)
                    | (0U <<  8U)
                    | (0U <<  9U)
                    | (0U << 10U)
                    | (0U << 11U)
                    | (0U << 12U)
                    | (0U << 13U)
                    | (0U << 14U)
                    | (0U << 15U);

    /* enable interrupts */
    vimREG->REQMASKSET0 = 
                          (1U <<  2U)
                        | (0U <<  3U)
                        | (0U <<  4U)
                        | (0U <<  5U)
                        | (0U <<  6U)
                        | (0U <<  7U)
                        | (0U <<  8U)
                        | (0U <<  9U)
                        | (0U << 10U)
                        | (0U << 11U)
                        | (0U << 12U)
                        | (0U << 13U)
                        | (0U << 14U)
                        | (0U << 15U)
                        | (0U << 16U)
                        | (0U << 17U)
                        | (0U << 18U)
                        | (0U << 19U)
                        | (0U << 20U)
                        | (0U << 21U)
                        | (0U << 22U)
                        | (0U << 23U)
                        | (0U << 24U)
                        | (0U << 25U)
                        | (0U << 26U)
                        | (0U << 27U)
                        | (0U << 28U)
                        | (0U << 29U)
                        | (0U << 30U)
                        | (0U << 31U);

    vimREG->REQMASKSET1 = 0U
                        | (0U << 1U)
                        | (0U << 2U)
                        | (0U << 3U)
                        | (0U << 4U)
                        | (0U << 5U)
                        | (0U << 6U)
                        | (0U << 7U)
                        | (0U << 8U)
                        | (0U << 9U)
                        | (0U << 10U)
                        | (0U << 11U)
                        | (0U << 12U)
                        | (0U << 13U)
                        | (0U << 14U)
                        | (0U << 15U);
#endif  

    
    
        /* To RTI CAPCNTR0*/
        captureEventSource0(); 

        /* To RTI CAPCNTR1*/
        captureEventSource1(); 
    
/* USER CODE BEGIN (4) */
/* USER CODE END */
}





/*- End of sys_startup.c ----------------------------------------------*/




