

#include "../chip_libs/system.h"

#include <stdio.h>
#include "../chip_libs/sci.h" // for sciNotification below
#include "../chip_libs/adc.h" // for adcBASE_t below
#include "../chip_libs/c_can.h" // for canBASE_t below
void    edgeNotification(unsigned edge){return;}
void	gioNotification(int bit){return;}
void    pwmNotification(unsigned pwm, unsigned notification){return;}
void	sciNotification(sciBASE_t *sci, unsigned flags){return;}
void adcNotification(adcBASE_t *adc, unsigned group){return;}
void rtiNotification(unsigned notification){return;}

//void vPortPreemptiveTick(){while(1); }


#include "../chip_libs/het.h"
/* FreeRTOS includes */
#include "../RTOS/include/FreeRTOS.h"
#include "../RTOS/include/task.h"
#include "../RTOS/include/queue.h"
#include "../RTOS/include/semphr.h"

//signed char traceBuff[255];

void vTask1( void *pvParameters )
{
    volatile unsigned long ul;
    static unsigned long ulCounter = 0UL;
    char str[16];
    static unsigned long toggle = 0x00;

    /* As per most tasks, this task is implemented in an infinite loop. */
    for( ;; )
    {
        ulCounter++;
        //sprintf(str, "Task1: %d", ulCounter);
        sciSend(sciREG2, 16, str);  // this is actually SCI1
        toggle ^= 0x01;
		if (toggle)
		{
			//GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_0, GPIO_PIN_0);
			hetREG->DSET   	= 0x00000002; /** - Set NHET Pin 0 */
		}
		else
		{
			//GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_0, 0);
			hetREG->DCLR   	= 0x00000002; /** - Clear NHET Pin 0 */
		}

//        /* Delay for a period. */
		vTaskDelay(500 / portTICK_RATE_MS);

    }
}

void vTask2( void *pvParameters )
{
	/* As per most tasks, this task is implemented in an infinite loop. */
    for( ;; )
    {

//        /* Delay for a period. */
        vTaskDelay(10 / portTICK_RATE_MS);

        TOGGLE_HET(0x00000004); /** - Clear NHET Pin 2 */
    }
}



void _main(void)
{
/* USER CODE BEGIN (2) */
	/** - Configure GIO for LED demo Software */
		gioInit();
		hetInit();
		sciInit();
		adcInit();
		ccanInit();


	/*-------------------------------------------
		 Create task and start scheduler
	-------------------------------------------*/

	/* Create one of the two tasks. */
	xTaskCreate(    vTask1,     /* Pointer to the function that implements the task. */
					"Task 1",   /* Text name for the task.  This is to facilitate debugging only. */
					240,        /* Stack depth in words. */
					NULL,       /* We are not using the task parameter. */
					1,          /* This task will run at priority 1. */
					NULL );     /* We are not using the task handle. */

	/* Create the other task in exactly the same way. */
	xTaskCreate( vTask2, "Task 2", 240, NULL, 2, NULL );

	//vTaskStartTrace(&traceBuff[0], 255);

	/* Start the scheduler so our tasks start executing. */
	vTaskStartScheduler();

	/* If all is well we will never reach here as the scheduler will now be
	running.  If we do reach here then it is likely that there was insufficient
	heap available for the idle task to be created. */
	while (1)
	{
	}

}




void vApplicationTickHook( void )
{
}

void vApplicationMallocFailedHook( void )
{
	for( ;; );
}
